/**********************************************/
/* Module to write text on any bit boundry    */
/* on graphics screens supported by Turbo C++ */
/* Compiler.                                  */
/*                                            */
/* Last Edit : 1/4/91                         */
/* (c)copyright 1991, Michael Chapin          */
/**********************************************/

#define BF8x8 0x0100
#define BF8x14 0x0200
#define BF8x16 0x0300
#define Transparent 0xFFFF

typedef enum {JStart, JCenter, JEnd} Justification;
typedef enum {DAcross, DDown} Direction;
typedef enum {FALSE, TRUE} BOOL;

typedef struct{
  unsigned Color;        /* Current writing color */
  unsigned BgColor;
  unsigned Width;        /* Width of font */
  Justification Justify;
  Direction Dir;
  unsigned Height;
}BFont;

typedef struct{
  unsigned x, y;
}CurrPt;


void SetBFonts();
/* sets up fonts */

void SetBFColor(unsigned Which, char Color);
/* Sets the color for printing "Which" Font */

char GetBFColor(unsigned Which);
/* Returns the current color for "Which" font */

void SetBFBgColor(unsigned Which, char Color);

char GetBFBgColor(unsigned Which);

void SetBFJust(unsigned Which, Justification Just);
/* Sets the justification for printing a Bios Font */

void SetBFFont(unsigned Which);
/* Sets the current font that will be written */

unsigned GetCurrBFFont(void);
/* Returns the current active font */

Justification GetBFJust(unsigned Which);
/* Returns the current Justification for "Which" font */

void SetBFDir(unsigned Which, Direction Dir);
/* Sets the direction for printing a Bios Font */

Direction GetBFDir(unsigned Which);
/* Returns the current direction for "Which" font */

void GetBFRecord(unsigned Which, BFont *Rec);
/* Returns the current setings for "Which" font */

unsigned GetBFWidth(unsigned Which, char *Strg);
/* Returns the width of a string in pixels if direction is DAcross */
/* else returns height of string in scan lines.                    */

unsigned GetBFHeight(unsigned Which);
/* Returns height of "Which" Font */

void PrintBF(char *Msg);
/* Prints a font at the current font pointer coordinates.  The font pointer */
/* is updated to the end of string that was printed.                        */

void PrintBFAt(unsigned x, unsigned y, char *Msg);
/* Prints a font at x, y without changing the font pointer */

void MoveBFCursor(unsigned x, unsigned y);
/* Moves the internal cursor used by PrintBF to (x, y) */

void GetBFCursor(unsigned *x, unsigned *y);
/* returns the current value of the internal cursor in x and y */

void print_char(unsigned x, unsigned y, unsigned color, unsigned height,
                unsigned char far *pattern);
/* low level printing routine for implement the users own font schemes. */

void ColorBlock(unsigned x, unsigned y, unsigned width,
                unsigned height, unsigned color);
